<template>
  <div>
  <b-btn type="button" class="btn" v-b-modal="post.post_id">Update</b-btn>

  <b-modal :id="post.post_id" title="Update Post" hide-footer="true" ref="myModalRef">
    <b-form @submit="onSubmit" @reset="onReset">
      <b-form-input v-model="form.post_title"
                    type="text"
                    :placeholder= "post.post_title"
                    name="post_title">
      </b-form-input>
      <label>Text will not be updated if input field is clear</label>
      <br>
      <b-form-textarea v-model="form.post_text"
                       :placeholder= "post.post_text"
                       :rows="3"
                       :max-rows="10"
                       name="post_text">
      </b-form-textarea>
      <label>Text will not be updated if input field is clear</label>
      <br>
      <br>
      <b-button type="submit" variant="primary">Submit</b-button>
      <b-button type="reset" variant="danger">Reset</b-button>
    </b-form>
  </b-modal>
</div>
</template>

<script>
  var $ = require ("jquery");
    export default {
      data () {
        return {
          form: {
            post_title: '',
            post_text: '',
          }
        }
      },
      props: {
        post: {}
      },
      methods: {
        onSubmit (evt) {

          evt.preventDefault();
          //Get Form
          var data = JSON.stringify(this.form);
          var postID = this.post.post_id;
          var path = "/api/post/"+postID;
          $.ajax({
            type: "PUT",
            enctype: 'json',
            url: path,
            dataType: "json",
            data: data,
            processData: false,
            contentType: false,
            cache: false,
            timeout: 600000,
            success: function () {
               location.reload();
            },
            error: function () {
              alert("Error");
            }
          });

        },
        onReset (evt) {
          evt.preventDefault();
          /* Reset our form values */
          this.form.post_title = '';
          this.form.post_text = '';
          /* Trick to reset/clear native browser form validation state */
        }
      }

    }
</script>

<style scoped>
  .btn {
    float: right;
    font-size: 14px;
    border: none;
    background: rgb(184, 56, 56);
    color: white;
  }
</style>
